(define (make-exp op left right)
  (list op left right))

(define (operator exp)
  (car exp))

(define (left exp)
  (cadr exp))

(define (right exp)
  (caddr exp))

(define (pre-order exp)
  (if (not (pair? exp))
      (list exp)
      (append (list (operator exp))
              (pre-order (left exp))
              (pre-order (right exp)))))

(define (in-order exp)
  (if (not (pair? exp))
      (list exp)
      (append (in-order (left exp))
              (list (operator exp))
              (in-order (right exp)) )))

(define (post-order exp)
  (if (not (pair? exp))
      (list exp)
      (append (post-order (left exp))
              (post-order (right exp))
              (list (operator exp)))))

(define a '(+ 1 2))                     ; 1+2=3
(define b (make-exp '* a 3))            ; (1+2)*3 = 9
(define c (make-exp '/ a (make-exp '+ 3 4)))  ; (1+2)/(3+4) = 3/7
(define d (make-exp '* c (make-exp '/ 1 c)))  ; c * (1/c) = 1
(define e '(+ 1 (* 2 3)))               ; (1+(2*3)) = 7
(define f '(+ 1 (* 2 (- 3 5))))         ; (1+(2*(3-5))) = -3

'pre-order
(pre-order a)
(pre-order b)
(pre-order c)
(pre-order d)
(pre-order e)
(pre-order f)

'in-order
(in-order a)
(in-order b)
(in-order c)
(in-order d)
(in-order e)
(in-order f)

'post-order
(post-order a)
(post-order b)
(post-order c)
(post-order d)
(post-order e)
(post-order f)
